
{$APPTYPE GUI}{$MODE DELPHI}

program DemoShells;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_Shells;

//const
 
//type
  
//var 
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(1,1, 0,1, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, 1,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('GuscioInt00.bmp',0);
  TextureLoadID('guscio03.bmp',1);  
  TextureLoadID('guscio02.bmp',2); 
  TextureLoadID('guscio01.bmp',3);  
  TextureLoadID('guscio00.bmp',4);  
  TextureLoadID('guscio04.bmp',5);
  TextureLoadID('guscio05.bmp',6);  
  TextureLoadID('guscio06.bmp',7);
  
end;
begin 

  OpenGL_Texture();
  
  
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-1,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(30,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,0, 0.1); 

  TextureOFF; 
  Quad(-10,0,-10, 10,0,-10, -10,0,10, 10,0,10);
  TextureON;
  
  TextureSelectID(1);
  glPushMatrix;
  glTranslatef(-5,0,-6);
  SpiralShell(6, 21,1,0, 0.25,1,0.2, 1,0.5,0, 80,20, 1/2);
  glPopMatrix;   
  TextureSelectID(0);
  glPushMatrix;    
  glTranslatef(-5,0.02,-6);
  SpiralShell(6, 21,1,0, 0.25,0.98,0.2, 1,0.5,0, 80,20, 1/2);
  glPopMatrix;  
  
  TextureSelectID(2);  
  glPushMatrix;
  glTranslatef(0,1.5,-6);  
  SpiralShell(6, 30,-1,0, 0.16,1,0.2, 1,0.4,0.25, 128,32, 1/2.5);
  TextureSelectID(0);
  SpiralShell(6, 30,-1,0, 0.16,0.98,0.2, 1,0.4,0.25, 128,32, 1/2.5);
  glPopMatrix;  
  
  TextureSelectID(3);
  glPushMatrix;
  glTranslatef(5,0,-6);   
  SpiralShell(6, 35,-1,0, 0.15,1,0.2, 1,0.05,0, 64,20, 1);
  glPopMatrix;   
  TextureSelectID(0);
  glPushMatrix;    
  glTranslatef(5,0.02,-6);  
  SpiralShell(6, 35,-1,0, 0.15,0.98,0.2, 1,0.05,0, 64,20, 1);
  glPopMatrix; 
  
  TextureSelectID(4);
  glPushMatrix;
  glTranslatef(-6,0.5,0);   
  SpiralShell(4, 25,1,0, 0.26,1.25,0.3, 1,0,0, 128,20, 2);
  glPopMatrix;
  
  TextureSelectID(1);
  glPushMatrix;  
  glTranslatef(-1.5,0,0);    
  SpiralShell(12, 90,-1,0, 0.02,0.3,0.2, 1,0.1,0, 180,64, 1);
  glPopMatrix;   
  TextureSelectID(0); 
  glPushMatrix;  
  glTranslatef(-1.5,0.02,0);  
  SpiralShell(12, 90,-1,0, 0.02,0.28,0.2, 1,0.1,0, 180,64, 1);  
  glPopMatrix;  
  
  TextureSelectID(1);
  glPushMatrix;
  glTranslatef(1.5,0.2,0);
  SpiralShell2(12, 90,-1,0, 0.02,0.3,0.2, 1,0.1,0, 180,64, 2,1, 20,10, 1);  
  glPopMatrix; 
  TextureSelectID(0);  
  glPushMatrix;
  glTranslatef(1.5,0.24,0);
  SpiralShell2(12, 90,-1,0, 0.02,0.28,0.2, 1,0.1,0, 180,64, 2,1, 20,10, 1);  
  glPopMatrix;  
  
  TextureSelectID(5);  
  glPushMatrix;
  glTranslatef(5,0,0);  
  SpiralShell2(6, 30,-1,0, 0.14,1,0.2, 0.4,0.1,0, 180,64, 1,1, 3,1, 1/2.5);
  glPopMatrix;  
  TextureSelectID(0);
  glPushMatrix;
  glTranslatef(5,0.02,0);    
  SpiralShell2(6, 30,-1,0, 0.14,0.98,0.2, 0.4,0.1,0, 180,64, 1,1, 3,1, 1/2.5);
  glPopMatrix;    
  
  TextureSelectID(6);  
  glPushMatrix;
  glTranslatef(-7,1.5,6);  
  SpiralShell2(6, 30,-1,0, 0.14,1,0.2, 0.4,0.3,0.2, 180,64, 2.5,0.5, 32,16, 1/2);
  glPopMatrix;  
  TextureSelectID(0);
  glPushMatrix;
  glTranslatef(-7,1.52,6);    
  SpiralShell2(6, 30,-1,0, 0.14,0.98,0.2, 0.4,0.3,0.2, 180,64, 2.5,0.5, 32,16, 1/3);
  glPopMatrix;      
  
  TextureSelectID(6);  
  glPushMatrix;
  glTranslatef(-2,1.5,8);  
  SpiralShell(7, 5,-1,0, 0.15,1,0.2, 0,0,0.07, 128,64, 1/6);
  glPopMatrix;  
  TextureSelectID(0);
  glPushMatrix;
  glTranslatef(-2,1.52,8);    
  SpiralShell(7, 5,-1,0, 0.15,0.98,0.2, 0,0,0.07, 128,64, 1/10);
  glPopMatrix;     
  
  TextureSelectID(7);  
  glPushMatrix;
  glTranslatef(6,3.5,6);  
  SpiralShell3(5, 30,-1,0, 0.14,1,0.2, 0.25,0.15,0.7,0, 128,2,12, 1/4);
  glPopMatrix;  
  TextureSelectID(0);
  glPushMatrix;
  glTranslatef(6,3.52,6);  
  SpiralShell3(5, 30,-1,0, 0.14,0.98,0.2, 0.25,0.15,0.7,0, 128,2,12, 1/2);
  glPopMatrix;       
  
  //SpiralShell(6, 60,0.56,0, 0.85,0.7,0.2, 0.3,0, 250,3, 1/3);    
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Dimostrazione sulla generare delle conchiglie', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
